﻿
var Deal = function (name, products) {
    this.name = ko.observable(name);
    this.products = ko.observableArray(products);
};

var Product = function (id, name, desc, price, priceDiscount, location, imgUrl, contents) {
    this.id = id;
    this.name = ko.observable(name);
    this.desc = ko.observable(desc);
    this.price = ko.observable(price);
    this.location = ko.observable(location);
    this.imgUrl = ko.observable(imgUrl);
};

var ProductDetails = function (id, productTyp, name, title, price, priceDiscount, location, address, imgUrl, contents, finePrint, highlights, expireDate, permalink, validity, contact, delivery, stock_status, looted, isVirtual) {
    this.id = id;
    this.productTyp = ko.observable(productTyp);
    this.name = ko.observable(name);
    this.title = ko.observable(title);
    this.price = ko.observable(price);
	this.stock_status = ko.observable(true);
    this.priceDiscount = ko.observable(priceDiscount);

    this.location = ko.observable(location);
    this.address = ko.observable(address);
    this.finePrint = ko.observable(finePrint);
    this.highlights = ko.observable(highlights);
	this.validity = ko.observable(validity);
	this.contact = ko.observable(contact);
	this.delivery = ko.observable(delivery);

    this.imgUrl = ko.observableArray(imgUrl);
    this.contents = ko.observable(contents);
    this.expireDate = ko.observable(expireDate);
	this.permalink = ko.observable(permalink);
	if (stock_status == 'outofstock')
		this.stock_status = ko.observable(false);

    this.youSave = ko.observable(price - priceDiscount);

    var discount = Math.round((((this.youSave()) / price) * 100));
    this.discountPer = ko.observable(discount);
	this.looted = ko.observable(looted);
	this.isVirtual = ko.observable(isVirtual);
	
};

var NewUserViewModel = function (email, pwd, confirmPwd, phone, dob, city, gender) {
    var self = this;
    self.email = ko.observable(email).extend({
        required: { message: 'Please specify your email address!' },
		email: true
    });

    self.pwd = ko.observable(pwd).extend({
        required: true,
        minLength: 3,
        maxLength: 16
    });

    self.confirmPwd = ko.observable(confirmPwd).extend({ required: true });
    self.phone = ko.observable(phone).extend({ required: true, minLength:10, maxLength:11 });
    self.dob = ko.observable(dob);
    self.city = ko.observable(city).extend({ required: true });
    self.gender = ko.observable(gender);

    self.rememberMe = ko.observable(false);
    self.regUsrCall = function(){
        if (self.isValid()) {
            bs.registerUsr(self, function (r) {
                if (r.status == "success") {
                    spm("User Registered successfully", 'success');
                    location.hash = "/signin";
                } else {
                    spm(r.error, 'danger');
                }
                hLdr();
            });
        }
    }
    self.isValid = function () {
        var iValid = false;

        iValid = self.email.isValid() && self.pwd.isValid() && self.confirmPwd.isValid() &&
                 self.phone.isValid() && self.city.isValid();

        if (!iValid) {
            spm("Please specify valid information", 'danger');
        }

        if (iValid) {
            if (!(self.pwd() == self.confirmPwd())) {
                iValid = false;
                spm("Confirmation Password do not match!", 'danger');
            }
        }
        return iValid;
    };

    

};


var AccountSettings = function (userId, firstName, lastName, pwd, confirmPwd) {
    this.userId = ko.observable(userId);
    this.firstName = ko.observable(firstName);
    this.lastName = ko.observable(lastName);
    this.pwd = ko.observable(pwd);
    this.confirmPwd = ko.observable(confirmPwd);
};

var MyAccount = function (userInfo, recentOrders, accountSettings, myAddress) {
    this.userInfo2 = userInfo;
    this.recentOrders = ko.observableArray(recentOrders);
    this.accountSettings = accountSettings;
    this.myAddress = ko.observableArray(myAddress);
};

var ForgotPwd = function (email) {
    var self = this;
    self.email = ko.observable(email).extend({
        required: { message: 'Please specify your email address!' },
		email: true
    });
    self.cancel = function () {
        defGal();
    };
};

var PostDeal = function (name, email, phone, companyName, city, message) {
    var self = this;
    self.name = ko.observable(name).extend({ required: true, minLength: 3});
    self.email = ko.observable(email).extend({
        required: { message: 'Please specify your email address!' },
		email: true
    });
    self.phone = ko.observable(phone).extend({ required: true, minLength: 10, maxLength:11});
    self.companyName = ko.observable(companyName).extend({ required: true, minLength: 3});
    self.cityOptionValues = ["Karachi", "Lahore", "Islamabad"];
    self.citySelectedValue = ko.observable(city);
    self.message = ko.observable(message).extend({ required: true, minLength: 20});

    self.submitpostdeal = function () {
        if (self.isValid()) {
            bs.postDeal(self, function (r) {
                defGal();
                spm("Thanks for contacting us! We will get in touch with you shortly.", 'success');
            });
        }
    };

    self.cancel = function () {
        defGal();
    };

    self.isValid = function () {
        var iValid = false;

        iValid = self.name.isValid() &&
            self.email.isValid() &&
            self.phone.isValid() &&
            self.companyName.isValid() &&
            self.citySelectedValue() &&
            self.message.isValid();


        if (!iValid) {
            spm("Please specify valid information", 'danger');
        }

        return iValid;
    };
};

var ContactUs = function (name, email, phone, message) {
    var self = this;
    self.name = ko.observable(name).extend({ required: true, minLength: 3});
    self.email = ko.observable(email).extend({
        required: { message: 'Please specify your email address!' },
		email: true
    });
    self.phone = ko.observable(phone).extend({ required: true, minLength: 10, maxLength:11});
    self.message = ko.observable(message).extend({ required: true, minLength: 20});

    self.submitcontactus = function () {
        if (self.isValid()) {
            bs.contactUs(self, function (r) {
                defGal();
                spm("Thanks for contacting us! We will get in touch with you shortly.", 'success');
            });
        }
    };

    self.cancel = function () {
        defGal();
    };

    self.isValid = function () {
        var iValid = false;

        iValid = self.name.isValid() &&
            self.email.isValid() &&
            self.phone.isValid() &&
            self.message.isValid();


        if (!iValid) {
            spm("Please specify valid information", 'danger');
        }

        return iValid;
    };
};

var Cart = function (id, productId, name, title, price, qty, total, imgUrl, productAttr, productTyp, isVirtual) {
    this.id = ko.observable(id);
    this.productId = ko.observable(productId);
    this.name = ko.observable(name);
    this.title = ko.observable(title);
    this.price = ko.observable(price);
    this.qty = ko.observable(qty);
    this.total = ko.observable(total);
    this.imgUrl = ko.observable(imgUrl);
    this.productAttr = productAttr;
	this.productTyp = ko.observable(productTyp);
	this.isVirtual = ko.observable(isVirtual);
};

var ProductAttributes = function (attr, value) {
    var self = this;
    self.attr = ko.observable(attr);
    self.value = ko.observable(value);
};

var ManageCart = function (cartItems) {
    var self = this;
    self.data = ko.observableArray(cartItems);

    self.cancel = function () {
        defGal();
    };
};

var favModel = function (prods) {
    var self = this;
    self.data = ko.observableArray(prods);

    self.cancel = function () {
        defGal();
    };
};

var PaymentCheckout = function (myAddress, cartItems, shippingCost) {
    var self = this;
    self.isNewUser = ko.observable(false);
    self.myAddress = ko.observableArray(myAddress);
    self.cartData = ko.observableArray(cartItems);
	self.funds = ko.observable(0);
	self.isVirtual = ko.observable(0);
	
    self.paymentType = ko.observable("Cash on Delivery");
    self.pmtCod = ko.observable("cod");
    self.orderTotal = ko.observable();

    self.shippingCost = ko.observable();
    self.calcShippingCost = function (sc) {
        if (sc == 0 || sc == "Free Shipping") {
            self.shippingCost("Free Shipping");
        } else {
            self.shippingCost("Rs: " + sc);
        }

        var res = parseInt(sc);
        if (isNaN(res)) {
            self.orderTotal(st);
        } else {
            self.orderTotal(parseInt(res) + parseInt(st) - self.orderDis());
        }
    };
    self.calcShippingCost(shippingCost);

    self.ccode = ko.observable();
    self.ccodeApply = function (a, b, c) {
        var plData = [];
        for (var key in myCart.data()) {
            var item = myCart.data()[key];
            plData.push({ id: item.productId(), quantity: item.qty(), variation_id: item.productAttr.variId() });
        }

        var cmcc = {
            cc: self.ccode(),
            pl: JSON.stringify(plData),
            tamt: self.orderTotal()
        };

        if (userInfo != undefined) {
            cmcc.email = userInfo.email;
        }

        bs.copApply(cmcc, function (r) {
            self.orderDis(Math.round(r.discount));
            self.orderTotal(self.orderTotal() - self.orderDis());
            self.vdis(true);
			if (r.success === "true")
				$("#dvCoup").hide();
			else
				self.ccode("");
        });

    };

    self.vdis = ko.observable(false);
    self.orderDis = ko.observable(0);

    var st = 0;
    myCart.data().forEach(function (item) {
        st += parseInt(item.total());
    });

    self.cartSubTotal = ko.observable(st);

    self.cancel = function () {
        manageCart(null);
    };

};

//var op = new OrderPlaced(p.order, p.order_date, p.order_total, p.payment_method, p.message, "", myCart.data(), vm.shippingCost(), selAdd, userInfo);
var OrderPlaced = function (orderId, orderDate, oTotal, paymentMethod, confirmationMessage, cartItems, shippingCost, orderDis, addressBilling, userInfo) {

    this.orderId = ko.observable(orderId);
    this.orderDate = ko.observable(orderDate);
    this.orderTotal = ko.observable(oTotal);
    this.paymentMethod = ko.observable(paymentMethod);
    this.confirmationMessage = ko.observable(confirmationMessage);

    this.shippingCost = ko.observable(shippingCost);
    this.orderDis = ko.observable();

    if (orderDis > 0) {
        this.vdis = ko.observable(true);
        this.orderDis(orderDis);
    } else {
        this.vdis = ko.observable(false);
    }

    this.addressBilling = addressBilling;
    this.userInfo2 = userInfo;
    this.cartData = cartItems;

    var st = 0;
    //myCart.data().forEach(function (item) {
    this.cartData.forEach(function (item) {
        st += item.total();
    });

    this.cartSubTotal = ko.observable(st);

};

var BillingAddress = function (id, firstName, lastName, email, phone, address, area, city, country) {
    this.id = ko.observable(id);
    this.firstName = ko.observable(firstName).extend({ required: true, minLength: 3});
    this.lastName = ko.observable(lastName).extend({ required: true, minLength: 3});
	this.email = ko.observable(email).extend({ required: { message: 'Please specify email address!' },email: true});
    this.phone = ko.observable(phone).extend({ required: true, minLength: 10, maxLength:12});
    this.address = ko.observable(address).extend({ required: true, minLength: 12});
    this.area = ko.observable(area);
    this.city = ko.observable(city).extend({ required: { message: "You must select city." }});
    this.country = ko.observable(country);
    this.pwd = ko.observable().extend({ required: true, minLength: 3});
    this.confirmPwd = ko.observable().extend({ required: true, minLength: 3});

    this.cancel = function () {
        myAccount("dvMyAddress");
    };

};

var KP = function (k, v, vari) {
    this.key = k;
    this.value = v;
    this.variation = vari;
};


var CreditCrd = function (orderId, ccNum, ccExpMon, ccExpYear, ccCode, ovm) {
    var self = this;
    self.orderId = ko.observable(orderId);

    self.ccNum = ko.observable(ccNum).extend({ required: true, minLength: 16});
    self.ccExpMon = ko.observable(ccExpMon).extend({ required: true, minLength: 2});
    self.ccExpYear = ko.observable(ccExpYear).extend({ required: true, minLength: 4});
    self.ccCode = ko.observable(ccCode).extend({ required: true, minLength: 3, maxLength: 4});

    self.submitCard = function () {
        if (self.isValid()) {
            bs.creditDet(self, function (r) {
                if (r.status == "failure") {
                    spm(r.message, 'danger');
                }
                else if (r.status == "success") {
                    orderPlacedVM(ovm);
                }
            });
        }
    };

    self.cancel = function () {
        //Last Screen
        var tmp = "";
    };

    self.isValid = function () {
        var iValid = false;

        iValid = self.ccNum.isValid() &&
            self.ccExpMon.isValid() &&
            self.ccExpYear.isValid() &&
            self.ccCode.isValid();

        if (!iValid) {
            spm("Please specify valid information", 'danger');
        }

        return iValid;
    };
};