﻿
var InitKoExt = function () {
    ko.extenders.addCurrencyFormatted = function (target, decimals) {
        target.formatted = ko.computed({
            read: function () {
                var val = target();
                var formattedValue = ('Rs. ' + val).replace(/\B(?=(\d{3})+(?!\d))/g, " ");
                return formattedValue;
            },
            write: function (newValue) {
                var current = target();
                var valueToWrite = formatToNumber(newValue, decimals);

                if (valueToWrite !== current) {
                    target(valueToWrite);
                } else {
                    if (newValue !== current) {
                        target.notifySubscribers(valueToWrite);
                    }
                }
            }
        });
        return target;
    };

    ko.extenders.addDecimal = function (target, decimals) {
        target.formatted = ko.computed({
            read: function () {
                var val = target();
                return val.toFixed(2);
            },
            write: function (newValue) {

            }
        });
        return target;
    };



    ko.observableArray.fn.pushAll = function (valuesToPush) {
        var underlyingArray = this();
        this.valueWillMutate();
        ko.utils.arrayPushAll(underlyingArray, valuesToPush);
        this.valueHasMutated();
        return this;
    };

};

var InitAppConf = function () {

    cMan();
    baseUrl = location.href;
    window.addEventListener("native.showkeyboard", function(e){ 
        $("#footer").hide();
    });
    window.addEventListener("native.hidekeyboard", function(e){ 
        $("#footer").show();
    });
    window.addEventListener("popstate", function (e) {
        var replaceStr = "file:///android_asset/www/index.html";
        var urlPart = location.href.replace(replaceStr, "");
        switch (urlPart) {
            case "/deals/Featured":
                galleryDeal("Featured");
                break;
            case "/deals/Hot":
                galleryDeal("Hot");
                break;
            case "/deals/Recent":
                galleryDeal("Recent");
                break;
			case "/categories":
                catView();
                break;
            case "/category/Accessories":
                catGallery("Accessories", "1137");
                break;
            case "/category/Beauty":
                catGallery("Beauty", "129");
                break;
            case "/category/Clothing":
                catGallery("Clothing", "1136");
                break;
            case "/category/Electronics":
                catGallery("Electronics", "1135");
                break;
            case "/category/Food":
                catGallery("Food", "132");
                break;
            case "/category/Footwear":
                catGallery("Footwear", "280");
                break;
            case "/category/Healthcare":
                catGallery("Healthcare", "130");
                break;
            case "/category/Jewelry":
                catGallery("Jewelry", "1138");
                break;
            case "/category/Lifestyle":
                catGallery("Lifestyle", "131");
                break;
			case "/man-cart":
                manageCart(null);
                break;
            default:
                //pushUrl("/deals/Featured");
                //galleryDeal("Featured");
                break;
        }
    });

    $(window).bind('hashchange', function () {
    });

    ko.validation.rules.pattern.message = 'Invalid.';
};
/*
var pushUrl = function (newUrlPart) {
    var newUrl = baseUrl + newUrlPart;
    history.pushState(null, null, newUrl);
    $("#footer").show();
};
*/

var sLdr = function () {
    isAppBsy = true;
    $.blockUI({
         message : '<img src="'+pathVar+'resources/images/loader/ajax-loader.gif">',
         css: { 
            border: 'none', 
            padding: '5px', 
            backgroundColor: '#fff', 
            '-webkit-border-radius': '5px', 
            '-moz-border-radius': '5px', 
            opacity: .8, 
            color: '#fff' 
        }
    }); 
};

var hLdr = function () {
    setTimeout(hla, 500);
};

var hla = function () {
    $.unblockUI({ fadeOut: 200 });
    isAppBsy = false;
    $("#contents").show();
   
};

var cMan = function () {
    catCache = undefined;
    dealCache = undefined;
    dealExpCache = undefined;
    dealActCache = undefined;
    setTimeout(cMan, 30000);
};

var scrFP = function () {
    sFlagActive = false;
};

var spm = function (message, msgtype) {
	if (!msgtype) msgtype = 'danger';
    var msgbody = '<div class="alert alert-'+msgtype+'"><a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a><strong>'+message+'</strong></div>';
    $("#pageMessage").html(msgbody);
    setTimeout(hpm, 3000);
};

var hpm = function () {
    $("#pageMessage").html("");
};

var toObjectArray = function (objectColl) {
    var arr = null;
    if (objectColl != null) {
        arr = $.map(objectColl, function (value, index) {
            value.id = index;
            return [value];
        });
    }
    return arr;
};


var toObjectArray2 = function (objectColl) {
    var arr = null;
    if (objectColl != null) {
        arr = $.map(objectColl, function (value, index) {
            return [{ index: value }];
        });
    }
    return arr;
};

var toAddrObjArr = function (objectColl) {
    var arr = null;
    if (objectColl != null) {
        arr = $.map(objectColl, function (value, index) {
            value.idx = index;
            return [value];
        });
    }
    return arr;
};

function fndCrt(source, model) {
    for (var i = 0; i < source.length; i++) {
        if (source[i].productId() === model.id) {
            return source[i];
        }
    }
    return null;
}

function fndAddr(source, valueToFind) {
    for (var i = 0; i < source.length; i++) {
        if (source[i].default === valueToFind) {
            return source[i];
        }
    }
    return null;
}

function xremCrt(source, model) {
    for (var i = 0; i < source.length; i++) {
        if (source[i].productId() === model.productId()) {
            var tmp = source.remove(model);
        }
    }
    return null;
}

var cloneko = function (source, keys) {
    var oc = [];

    source.forEach(function (item) {
        var newObject = {};
        keys.forEach(function (key) {
            newObject[key] = item[key]();
        });
        oc.push(newObject);
    });
    return oc;
};


var clonekoCus = function (source, keys) {
    var oc = [];

    source.forEach(function (item) {
        var newObject = {};
        keys.forEach(function (key) {
            newObject[key] = item[key]();
        });

        newObject.variId = item.productAttr.variId();
        oc.push(newObject);
    });
    return oc;
};

var distFun = function (objArr) {
    return ko.utils.arrayGetDistinctValues(objArr).sort();
};

