﻿
define(function () {
	
    var env = 'live'; //change staging to live for production
    var bs = {
		app_os : "Android",
        servicsOpt: {
            key: "44945fd4-a5ec-11e4-89e3-184b93f75cba",
            type: "post",
            city: "karachi"
        },
        servicsUrl : (env === "live") ? "http://lootlo.pk/services/mp_serv.php" : "http://lootlopk.staging.wpengine.com/services/mp_serv.php",
        
		getAppVersion: function (cb) {

            $.getJSON(bs.servicsUrl, { method: "app_version", city: bs.servicsOpt.city, key: bs.servicsOpt.key },
                function (r, s, o) {
                    cb({ version: r.version });
                })
                .fail(function (r, s, o) {
                    spm("Services Failed", "danger");
                });
        },
		
        getCategoriesMenu: function (cb) {

            $.getJSON(bs.servicsUrl, { method: "cat", city: bs.servicsOpt.city, key: bs.servicsOpt.key },
                function (r, s, o) {
                    cb({ categories: r });
                })
                .fail(function (r, s, o) {
                    spm("Services Failed", "danger");
                });
        },
		
		getHomeDeals: function (cb) {

            var serviceUrl;
            var serviceOption;
            serviceUrl = bs.servicsUrl;
			serviceOption = { method: "home", city: bs.servicsOpt.city, key: bs.servicsOpt.key };

			//if (dealCache == undefined) {
				sLdr();
				$.getJSON(serviceUrl, serviceOption, function (r, s, o) {
					serviceOption = { method: "brand_menu", city: bs.servicsOpt.city, key: bs.servicsOpt.key, ishome:1 };
					$.getJSON(serviceUrl, serviceOption, function (inr, ins, ino) {
						r.brands = inr;
						//dealCache = r;
						cb(r);
					})
					.fail(function (r, s, o) {
						spm("Services Failed", "danger");
					});
				})
				.fail(function (r, s, o) {
					spm("Services Failed", "danger");
				});
			//} else {
			//	cb(dealCache);
			//}
        },
		
		getDealsNearMe: function (latlong, cb) {

            var serviceUrl;
            var serviceOption;
            serviceUrl = bs.servicsUrl;
			serviceOption = { method: "deals_near_me", city: bs.servicsOpt.city, key: bs.servicsOpt.key, latlong: latlong };
			//sLdr();
			$.getJSON(serviceUrl, serviceOption, function (r, s, o) {
				cb(r);
			})
			.fail(function (r, s, o) {
				spm("Services Failed", "danger");
			});
        },
		
        getDealsByType: function (selectDealType, cb) {

            var serviceUrl;
            var serviceOption;
            switch (selectDealType) {
                case "Featured":
                case "Hot":
                case "Recent":
                    serviceUrl = bs.servicsUrl;
                    serviceOption = { method: "home", city: bs.servicsOpt.city, key: bs.servicsOpt.key, showall:'yes' };

                    if (dealCache == undefined) {
                        sLdr();
                        $.getJSON(serviceUrl, serviceOption, function (r, s, o) {
                            dealCache = r;
                            cb(r);
                        })
                            .fail(function (r, s, o) {
                                spm("Services Failed", "danger");
                            });
                    } else {
                        cb(dealCache);
                    }
                    break;
                case "Active":
                    serviceUrl = bs.servicsUrl;
                    serviceOption = { method: "active", city: bs.servicsOpt.city, key: bs.servicsOpt.key };
                    if (dealActCache == undefined) {
                        sLdr();
                        $.getJSON(serviceUrl, serviceOption, function (r, s, o) {
                            dealActCache = r;
                            cb(r);
                        })
                            .fail(function (r, s, o) {
                                spm("Services Failed", "danger");
                            });
                    } else {
                        cb(dealActCache);
                    }
                    break;
                case "Expired":
                    expireDealListing(function (data) {
                        cb(data);
                    });
                    break;
            }
        },
		getBrandDeals: function (brandSlug, cb) {

            $.getJSON(bs.servicsUrl, { method: "brand_deals", product_brand: brandSlug, city: bs.servicsOpt.city, key: bs.servicsOpt.key },
                function (r, s, o) {
                    cb(r);
                })
                .fail(function (r, s, o) {
                    spm("Services Failed", "danger");
                });
        },

        getDealsExpired: function (cb, edp) {

            $.getJSON(bs.servicsUrl, { method: "expired", page: edp, city: bs.servicsOpt.city, key: bs.servicsOpt.key },
                function (r, s, o) {
                    dealExpCache = r;
                    cb(r);
                })
                .fail(function (r, s, o) {
                    spm("Services Failed", "danger");
                });
        },

        getProductsByCategory: function (cId, cb) {

            $.getJSON(bs.servicsUrl, { method: "cat_products", cat_id: cId, city: bs.servicsOpt.city, key: bs.servicsOpt.key },
                function (r, s, o) {
                    cb(r);
                })
                .fail(function (r, s, o) {
                    spm("Services Failed", "danger");
                });
        },

        searchProduct: function (text, cb) {

            $.getJSON(bs.servicsUrl, { method: "search_deal", search_text: text, city: bs.servicsOpt.city, key: bs.servicsOpt.key },
                function (r, s, o) {
                    cb(r);
                })
                .fail(function (r, s, o) {
                    spm("Services Failed", "danger");
                });
        },

        getProductDetails: function (productId, cb) {
            sLdr();
            var serviceOption = { method: "product_details", city: bs.servicsOpt.city, key: bs.servicsOpt.key, product_id: productId };
            $.getJSON(bs.servicsUrl, serviceOption, function (r, s, o) {
                var p = r.product.post;
                var cdAddr = null, cdFP = null, cdHl = null, cdVv = null, cdCt = null, cdDt = null;
                if (p.post_custom_data != undefined) {
                    cdAddr = p.post_custom_data.Address;
                    cdFP = p.post_custom_data.FinePrint ||  p.post_custom_data.Fineprint;
                    cdHl = p.post_custom_data['Highlights'];
					cdVv = p.post_custom_data['VoucherValidity'];
					cdCt = p.post_custom_data['Contact&Timings'];
					cdDt = p.post_custom_data['DeliveryTiming'];
                }

                var vm = new ProductDetails(p.ID, p.product_type, p.post_name, p.post_title, p.org_price, p.discount_price, p.location, cdAddr, p.images, p.post_content, cdFP, cdHl, p.expire_date, p.permalink, cdVv, cdCt, cdDt, r.product.stock_status, p.looted, p.isVirtual);
                vm.isBundle = p.isBundle;
                vm.pc = p.products_count;
                vm.attributes = p.attributes;
                vm.manageStock = p.manage_stock;
                vm.purchaseLim = p.purchase_limit;


                cb(vm);
            })
            .fail(function (r, s, o) {
                spm("Services Failed", "danger");
            });
        },

        registerUsr: function (newModel, cb) {
            sLdr();
            var serviceOption = { method: "user_register", city: bs.servicsOpt.city, key: bs.servicsOpt.key, user_email: newModel.email(), user_pass: newModel.pwd(),
				user_phone:newModel.phone(), user_dob:newModel.dob(), user_gender:newModel.gender()};
			$.getJSON(bs.servicsUrl, serviceOption, function (r, s, o) {
                cb(r);
            })
			.fail(function (r, s, o) {
				spm("Services Failed");
				hLdr();
			});
        },
		
		connectWithFB: function (newModel, cb) {
            sLdr();
            var serviceOption = { method: "connect_with_fb", city: bs.servicsOpt.city, key: bs.servicsOpt.key, user_email: newModel.email, fb_id: newModel.id,
				user_name:newModel.name, first_name:newModel.first_name, last_name:newModel.last_name, user_gender:newModel.gender, profile_link:newModel.link, thumbnail:newModel.thumbnail};
			$.getJSON(bs.servicsUrl, serviceOption, function (r, s, o) {
                cb(r);
            })
			.fail(function (r, s, o) {
				spm("Services Failed");
				hLdr();
			});
        },
		
		registerDevice: function (regID, cb) {
			sLdr();
            var serviceOption = { method: "device_register", city: bs.servicsOpt.city, key: bs.servicsOpt.key, regid: regID };
            $.getJSON(bs.servicsUrl, serviceOption, function (r, s, o) {
                cb(r);
            })
                .fail(function (r, s, o) {
                    spm("Services Failed", "danger");
                    hLdr();
                });
        },
		
		getUserFunds: function (userID, cb) {
			sLdr();
            var serviceOption = { method: "get_user_funds", city: bs.servicsOpt.city, key: bs.servicsOpt.key, user_id: userID };
            $.getJSON(bs.servicsUrl, serviceOption, function (r, s, o) {
                cb(r);
            })
                .fail(function (r, s, o) {
                    spm("Services Failed", "danger");
                    hLdr();
                });
        },

        signInMe: function (model, cb) {
            var serviceOption = { method: "user_login", city: bs.servicsOpt.city, key: bs.servicsOpt.key, user_email: model.email(), user_pass: model.pwd() };
            $.getJSON(bs.servicsUrl, serviceOption, function (r, s, o) {
                cb(r);
            })
                .fail(function (r, s, o) {
                    spm("Services Failed", "danger");
                });
        },

        forgotPwd: function (model, cb) {
            sLdr();
            var serviceOption = { method: "forgot_password", city: bs.servicsOpt.city, key: bs.servicsOpt.key, user_login: model.email(), reset: true };
            $.getJSON(bs.servicsUrl, serviceOption, function (r, s, o) {
                cb(r);
            })
                .fail(function (r, s, o) {
                    spm("Services Failed", "danger");
                });
        },

        getRecentOrders: function (userId, cb) {
            var serviceOption = { method: "recent_orders", city: bs.servicsOpt.city, key: bs.servicsOpt.key, user_id: userId };
            $.getJSON(bs.servicsUrl, serviceOption,
                function (r, s, o) {
                    var recentOrders = r;
                    cb(recentOrders);
                })
                .fail(function (r, s, o) {
                    spm("Services Failed", "danger");
                });
        },

        updateAccountSettings: function (userId, model, cb) {
            var serviceOption = { method: "account_settings_update", city: bs.servicsOpt.city, key: bs.servicsOpt.key, user_id: userId, first_name: model.firstName(), last_name: model.lastName(), user_pass: model.pwd() };
            $.getJSON(bs.servicsUrl, serviceOption,
                function (r, s, o) {
                    cb(r);
                })
                .fail(function (r, s, o) {
                    spm("Services Failed", "danger");
                });
        },

        creditDet: function (vm, cb) {
            sLdr();
            //method=online_payment
            //order_id=141862&cnum=999000000000011&cexp_m=11&cexp_y=2016&ccode=1234			
            var serviceOption = {
                method: "online_payment",
                city: bs.servicsOpt.city,
                key: bs.servicsOpt.key,

                order_id: vm.orderId(),
                cnum: vm.ccNum(),
                cexp_m: vm.ccExpMon(),
                cexp_y: vm.ccExpYear(),
                ccode: vm.ccCode()
            };

            $.getJSON(bs.servicsUrl, serviceOption, function (r, s, o) {
                cb(r);
                hLdr();
            })
            .fail(function (r, s, o) {
                spm("Services Failed", "danger");
                hLdr();
            });
        },
        getMyAddress: function (userId, cb) {
            var serviceOption = { method: "my_address_view", city: bs.servicsOpt.city, key: bs.servicsOpt.key, user_id: userId };
            $.getJSON(bs.servicsUrl, serviceOption,
                function (r, s, o) {
                    cb(toObjectArray(r.addresses));
                })
                .fail(function (r, s, o) {
                    spm("Services Failed", "danger");
                });
        },

        postDeal: function (vm, cb) {
            var serviceOption = {
                method: "post_a_deal",
                city: bs.servicsOpt.city,
                key: bs.servicsOpt.key,
                name: vm.name(),
                email: vm.email(),
                phone: vm.phone(),
                companyName: vm.companyName(),
                dealCity: vm.citySelectedValue(),
                message: vm.message()
            };

            $.getJSON(bs.servicsUrl, serviceOption, function (r, s, o) {
                cb(r);
            })
                .fail(function (r, s, o) {
                    spm("Services Failed", "danger");
                });
        },

        contactUs: function (vm, cb) {
            var serviceOption = {
                method: "contact_us",
                city: bs.servicsOpt.city,
                key: bs.servicsOpt.key,
                name: vm.name(),
                email: vm.email(),
                phone: vm.phone(),
                message: vm.message()
            };

            $.getJSON(bs.servicsUrl, serviceOption, function (r, s, o) {
                cb(r);
            })
                .fail(function (r, s, o) {
                    spm("Services Failed", "danger");
                });
        },

        postAddress: function (uid, vm, cb) {

            vm.area(vm.areaSelectedValue());
            vm.city(vm.citySelectedValue());

            var serviceOption = {
                method: "add_address",
                city: bs.servicsOpt.city,
                key: bs.servicsOpt.key,
                user_id: uid,
                billing_first_name: vm.firstName(),
                billing_last_name: vm.lastName(),
                billing_email: vm.email(),
                billing_phone: vm.phone(),
                billing_address_1: vm.address(),
                billing_state: vm.areaSelectedValue(),
                billing_country: vm.citySelectedValue(),
                ref: "ll_multi_add"
            };

            $.getJSON(bs.servicsUrl, serviceOption, function (r, s, o) {
                cb(r);
            })
                .fail(function (r, s, o) {
                    spm("Services Failed", "danger");
                });
        },

        editAddress: function (userId, model, cb) {

            var serviceOption = { method: "edit_address", city: bs.servicsOpt.city, key: bs.servicsOpt.key, user_id: userId, address_id: model.id, billing_first_name: model.firstName(), billing_last_name: model.lastName(), billing_address_1: model.address(), billing_email: model.email(), billing_phone: model.phone(), billing_state: model.area(), billing_country: model.city() };
            $.getJSON(bs.servicsUrl, serviceOption,
                function (r, s, o) {
                    cb(r);
                })
                .fail(function (r, s, o) {
                    spm("Services Failed", "danger");
                });
        },

        deleteAddress: function (userId, model, cb) {
            var serviceOption = { method: "delete_address", city: bs.servicsOpt.city, key: bs.servicsOpt.key, address_id: model.id, user_id: userId };
            $.post(bs.servicsUrl, serviceOption, function (r, s, o) {
                cb(r);
            }, 'json')
                .fail(function (r, s, o) {
                    spm("Services Failed", "danger");
                });
        },

        shippingCost: function (prodList, shippingCity, cb) {
            var serviceOption = { method: "shipping_cost", city: bs.servicsOpt.city, key: bs.servicsOpt.key, product_list: prodList, shipping_city: shippingCity };
            $.post(bs.servicsUrl, serviceOption, function (r, s, o) {
                cb(r);
            }, 'json');
        },

        placeOrder: function (uid, sa, vm, cb) {
			
            var iValid =
                sa.firstName.isValid() &&
                sa.lastName.isValid() &&
                sa.email.isValid() &&
                sa.phone.isValid() &&
                sa.pwd.isValid() &&
                sa.confirmPwd.isValid();

            if (vm.isNewUser() == false) {
                if (sa.id() == undefined) {
                    spm("Please select address from address list");
                    return;
                }
            }
            
            if (!iValid) {
                spm("Please specify required information",'danger');
                return;
            }

            if (iValid) {
                if (!(sa.pwd() == sa.confirmPwd())) {
                    iValid = false;
                    spm("Confirmation Password do not match!",'danger');
                    return;
                }
            }


            sLdr();
            var plData = [];
            for (var key in myCart.data()) {
                var item = myCart.data()[key];
                if (item.productAttr.attr().length > 0) {
                    $.each(item.productAttr.variId(), function(variKey, variValue){
                        plData.push({ id: item.productId(), ptype:item.productTyp(), quantity: item.qty(), variation_id: variValue });
                    });
                } else {
                    plData.push({ id: item.productId(), quantity: item.qty(), variation_id: null });
                }

            }

            if (vm.isNewUser()) {

                var serviceOption = { method: "user_register", city: bs.servicsOpt.city, key: bs.servicsOpt.key, user_email: sa.email(), user_pass: sa.pwd() };
                $.getJSON(bs.servicsUrl, serviceOption, function (rnr, s, o) {
                    if (rnr.status == "failure") {
                        spm(rnr.error);
                        hLdr();
                        return;
                    }

                    var serviceOption = {
                        method: "add_address", city: bs.servicsOpt.city, key: bs.servicsOpt.key,
                        user_id: rnr.user_id,
                        billing_first_name: sa.firstName(),
                        billing_last_name: sa.lastName(),
                        billing_email: sa.email(),
                        billing_phone: sa.phone(),
                        billing_address_1: sa.address(),
                        billing_state: sa.areaSelectedValue(),
                        billing_country: sa.citySelectedValue(),
                        ref: "ll_multi_add"
                    };

                    $.getJSON(bs.servicsUrl, serviceOption, function (nua, s, o) {
                        var serviceOption = { method: "place_order", app_os:bs.app_os, city: bs.servicsOpt.city, key: bs.servicsOpt.key, customer_id: rnr.user_id, address_id: nua.address_id, product_list: JSON.stringify(plData), payment_method: vm.pmtCod() , coupon_applied:vm.ccode()};

                        $.post(bs.servicsUrl, serviceOption, function (r, s, o) {
                            hLdr();
                            cb(r);
                        }, 'json')
                        .fail(function (r, s, o) {
                            cb(r);
                            hLdr();
                        });
                    })
                    .fail(function (r, s, o) {
                        hLdr();
                        spm("Services Failed", "danger");
                    });

                })
                .fail(function (r, s, o) {
                    hLdr();
                    spm("Services Failed", "danger");
                });

            } else {

                var serviceOption = { method: "place_order", app_os:bs.app_os, city: bs.servicsOpt.city, key: bs.servicsOpt.key, customer_id: uid, address_id: sa.id(), product_list: JSON.stringify(plData), payment_method: vm.pmtCod() , coupon_applied:vm.ccode()};
                $.post(bs.servicsUrl, serviceOption, function (r, s, o) {
                    cb(r);
                }, 'json')
                .fail(function (r, s, o) {
                    cb(r);
                    hLdr();
                });
                
            }
        },

        copApply: function (vmcc, cb) {
            sLdr();

            var serviceOption = { method: "coupon_info", city: bs.servicsOpt.city, key: bs.servicsOpt.key, coupon: vmcc.cc, email: vmcc.email, amount: vmcc.tamt, product_list: vmcc.pl };
            $.post(bs.servicsUrl, serviceOption, function (r, s, o) {
                hLdr();
                spm(r.message);
                cb(r);
            }, 'json')
                .fail(function (r, s, o) {
                    spm("Services Failed", "danger");
                    hLdr();
                });
        },

        checkdiscountfirstorder: function (userInfo, cb) {
            var serviceOption = { method: "discount_first_order", city: bs.servicsOpt.city, key: bs.servicsOpt.key, userinfo: userInfo };
            $.post(bs.servicsUrl, serviceOption, function (r, s, o) {
                cb(r);
            }, 'json')
            .fail(function (r, s, o) {
                spm("Services Failed", "danger");
            });

        }

    };

    return bs;

});

var expireDealListing = function (cb) {
    sLdr();
    expDealPg++;
    var serviceUrl = bs.servicsUrl;
    var serviceOption = { method: "expired", page: expDealPg, city: bs.servicsOpt.city, key: bs.servicsOpt.key };
    $.getJSON(serviceUrl, serviceOption,
        function (r, s, o) {
            cb(r);
        })
        .fail(function (r, s, o) {

        });
};



//self.isValid = function () {
//    var iValid = false;

//    iValid = self.email.isValid() &&
//    self.pwd.isValid() &&
//    self.confirmPwd.isValid();

//    if (!iValid) {
//        spm("Please specify valid information");
//    }

//    if (iValid) {
//        if (!(self.pwd() == self.confirmPwd())) {
//            iValid = false;
//            spm("Confirmation Password do not match!");
//        }
//    }
//    return iValid;
//};




